#include <string.h>
#include <SPI.h>
#include "pins_arduino.h"
#include "Vinculum_SPI.h"
#include "WProgram.h"

Vinculum_SPI::Vinculum_SPI(){
  
}
void Vinculum_SPI::begin(void){	
	SPI.begin();
	SPI.setClockDivider(SPI_CLOCK_DIV128);
	SPI.setBitOrder(MSBFIRST);
	SPI.setDataMode(SPI_MODE0);
}
void Vinculum_SPI::SpiWrite(byte data){
  digitalWrite(SS, HIGH);
  SPI.transfer(byte((data>>5)|0x20));
  SPI.transfer(byte((data<<3)|0x07));
  digitalWrite(SS, LOW);
}
char Vinculum_SPI::SpiRead(void){
  char result;
  digitalWrite(SS, HIGH);
  SPI.transfer(0x06);
  result = SPI.transfer(0x00);
  digitalWrite(SS, LOW);
  return result;
}
void Vinculum_SPI::SendData(char *data){
  do{
    SpiWrite(*data);
    data++;
  }
  while(*data != '\0');
}
void Vinculum_SPI::SendChar(char data){
  SpiWrite(data);
}

///////////////////function////////////////////////
void Vinculum_SPI::Config_Cmd(){
  SendData("IPA\r");
}
void Vinculum_SPI::OpenDir(){
  SendData("DIR\r");
}
void Vinculum_SPI::ChangeDir(char *FileName){
  SendData("CD ");
  SendData(FileName);
  SendChar('\r');
}
void Vinculum_SPI::MakeDir(char *FileName){
  SendData("MKD ");
  SendData(FileName);
  SendChar('\r');
}
void Vinculum_SPI::DeleteDir(char *FileName){
  SendData("DLD ");
  SendData(FileName);
  SendChar('\r');
}
void Vinculum_SPI::ListFile(char *FileName){
  SendData("DIR ");
  SendData(FileName);
  SendChar('\r');
}
void Vinculum_SPI::DeleteFile(char *FileName){
  SendData("DLF ");
  SendData(FileName);
  SendChar('\r');
}
void Vinculum_SPI::ReadFile(char *FileName){
  SendData("RD ");
  SendData(FileName);
  SendChar('\r');
}
void Vinculum_SPI::RenameFile_Dir(char *lastName, char *newName){
  SendData("REN ");
  SendData(lastName);
  SendChar(' ');
  SendData(newName);
  SendChar('\r');
}
void Vinculum_SPI::CloseFile(char *FileName){
  SendData("CLF ");
  SendData(FileName);
  SendChar('\r');
}
void Vinculum_SPI::Open_ReadFile(char *FileName, char *Byte){
  SendData("OPR ");
  SendData(FileName);
  SendData("\r");
  SendData("IPA\r");
  SendData("RDF ");
  SendData(Byte);
  SendData("\r");
  SendData("CLF ");
  SendData(FileName);
  SendData("\r");
}
void Vinculum_SPI::CreateFile(char *FileName){
  SendData("OPW ");
  SendData(FileName);
  SendChar('\r');
  SendData("CLF ");
  SendData(FileName);
  SendChar('\r');
}
void Vinculum_SPI::Write_CreateFile(char *FileName, char *data1){
  SendData("OPW ");
  SendData(FileName);
  SendChar('\r');
  SendData("IPA\r");
  SendData("WRF ");
  SendChar(strlen(data1));
  SendChar('\r');
  SendData(data1);
  SendChar('\r');
  SendData("CLF ");
  SendData(FileName);
  SendChar('\r');
}
////////////////////////////////////////////////////
Vinculum_SPI SPIVinculum = Vinculum_SPI();