// ensure this library description is only included once
#ifndef Vinculum_SPI_h
#define Vinculum_SPI_h

#include <SPI.h>
#include "WProgram.h"
#include "pins_arduino.h"
// library interface description
class Vinculum_SPI
{	
	public:
		Vinculum_SPI();
		void begin(void);
		void Config_Cmd();
		void OpenDir();
		void ChangeDir(char *FileName);
		void MakeDir(char *FileName);
		void DeleteDir(char *FileName);
		void ListFile(char *FileName);
		void DeleteFile(char *FileName);
		void ReadFile(char *FileName);
		void RenameFile_Dir(char *lastName, char *newName);
		void CloseFile(char *FileName);
		void Open_ReadFile(char *FileName, char *Byte);
		void CreateFile(char *FileName);
		void Write_CreateFile(char *FileName, char *data1);
		char SpiRead(void);
	private:
		void SpiWrite(byte data);
		void SendChar(char data);
		void SendData(char *data);
};
extern Vinculum_SPI SPIVinculum;

#endif